include \masm32\include\masm32rt.inc
uselib gdiplus

Png2Bmp 	PROTO: DWORD
initpng   	PROTO: DWORD
ShowWinErr  	PROTO: DWORD

GdiplusStartupInput	STRUCT
GdiplusVersion		dd ?
DebugEventCallback	dd ?
SuppressBackgroundThread	dd ?
SuppressExternalCodecs	dd ?
GdiplusStartupInput	ENDS

ImageCodecInfo		STRUCT
Clsid		dd ?, ?, ?, ?
FormatID		dd ?, ?, ?, ?
CodecName		dd ?
DllName		dd ?
FormatDescription		dd ?
FilenameExtension	dd ?
MimeType		dd ?
Flags		dd ?
Version		dd ?
SigCount		dd ?
SigSize		dd ?
SigPattern		dd ?
SigMask		dd ?
ImageCodecInfo		ENDS

.data
DestMime	db "image"
	db 11 dup(0)	; padding and space for /extension

.data?
GdiPLUS	dd ?	; handle to library
ptrCLSID	dd ?	; for GdipSaveImageToFile
GdiToken	dd ?	; set by GdiplusStartup
EncInfo	dd ?	; must be global for HeapAlloc
ClBuffer	dd MAX_PATH/4 dup(?)

.code
start:	mov esi, offset DestMime+5
	invoke GetCL, 2, esi
	.if eax!=1 || byte ptr [esi]!="/"
		mov dword ptr [esi], "pmb/"	; .bmp, default destination
	.endif
	mov esi, offset ClBuffer
	invoke GetCL, 1, esi
	.if eax!=1
		MsgBox 0, "Command line error", "Hi", MB_OK
	.else
		invoke Png2Bmp, esi
	.endif
	exit

Png2Bmp proc Src
LOCAL PngImage
LOCAL pImageSrc[256]:BYTE
call ClearLocVars
  push esi
  push edi
  push ebx
;  MsgBox 0, offset DestMime, "Hi", MB_OK
;		int 3
  invoke initpng, offset DestMime	; eg. image/jpeg
;  deb 1, "Init", eax, GdiPLUS
  .if eax
	mov esi, Src
	lea edi, pImageSrc
	xor eax, eax
	push edi
	.Repeat
		lodsb
		.if al=="."
			mov ebx, edi	; save the pos of the dot
		.endif
		stosw
	.Until al==0
	pop edi
	invoke GdipLoadImageFromFile, edi, addr PngImage		; Load the image from file
	.if eax
		invoke ShowWinErr, Src
	.else
		mov esi, offset DestMime+6
		.Repeat
			lodsb
			add ebx, 2
			mov byte ptr [ebx], al
		.Until al==0
		invoke GdipSaveImageToFile, PngImage, edi, ptrCLSID, 0	; Save it
		.if eax
			invoke ShowWinErr, chr$("GdipSaveImageToFile")
		.endif
		invoke GdipDisposeImage, PngImage				; Clean up: eax=0 means success
		.if eax
			invoke ShowWinErr, chr$("GdipDisposeImage")
		.endif
	.endif
	call uninitpng
  .endif
  pop ebx
  pop edi
  pop esi
  ret
Png2Bmp endp

initpng proc ptrMimeType:DWORD
LOCAL gdisi:GdiplusStartupInput
LOCAL encnum, encsize
LOCAL CurMimeAddr[20]:WORD
	call ClearLocVars
	push edi
	push ebx
	lea edi, CurMimeAddr
	invoke LoadLibrary, chr$("gdiplus.dll")
	mov GdiPLUS, eax
	test eax, eax
	je ipgRet									; GdiPlus.dll not found
	inc gdisi.GdiplusVersion					; must be 1
;	and gdisi.DebugEventCallback, 0	; these members cleared by ClearLocVars
;	and gdisi.SuppressBackgroundThread, 0
;	and gdisi.SuppressExternalCodecs, 0
	invoke GdiplusStartup, addr GdiToken, addr gdisi, 0		; 3rd arg [url=http://msdn.microsoft.com/en-us/library/ms534077%28VS.85%29.aspx]can be 0 if SuppressBackgroundThread is 0[/url]

;	Get the available encode settings: num = encoders available on this PC, size = total memory needed to store them
	invoke GdipGetImageEncodersSize, addr encnum, addr encsize
	mov EncInfo, rv(HeapAlloc, rv(GetProcessHeap), 0, encsize)
	invoke GdipGetImageEncoders, encnum, encsize, eax	; eax=EncInfo; fills the memory block with the encoding info
;	Check encoders until we find the matching one (e.g. image/png)
	invoke MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, ptrMimeType, -1, edi, 20
	mov ebx, EncInfo
@@:	invoke lstrcmpiW, edi, [ebx.ImageCodecInfo.MimeType]		; compare wide strings (case insensitive)
	test eax, eax
	jz MimeOK
	add ebx, sizeof ImageCodecInfo
	dec encnum
	jnz @B					; check next mime
	invoke MessageBox, 0, ptrMimeType, chr$("Mime type not found:"), MB_OK
	or eax, -1				; -1+1=0, flag error

MimeOK:
	mov ptrCLSID, ebx		; store for later use
	inc eax
ipgRet:
	pop ebx
	pop edi
	ret
initpng endp

uninitpng proc
  .if GdiPLUS
	invoke HeapFree, rv(GetProcessHeap), 0, EncInfo
	invoke GdiplusShutdown, GdiToken
	invoke FreeLibrary, GdiPLUS
;	and GdiPLUS, 0	; mark deleted
  .endif
  ret
uninitpng endp

ShowWinErr proc ShowWhere:DWORD
LOCAL ShowErrBuf[1024]:BYTE
  pushad
  lea edi, ShowErrBuf
  invoke GetLastError
  invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM,
  0,	; GetItFromSystem
  eax,	; ErrNum
  0,	; Default language
  edi,	; dest of string from system
  1024, 0	; size, no arguments
  MsgBox 0, edi, ShowWhere, MB_OK
  popad
  ret
ShowWinErr endp
ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
;  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp
end start

OPT_Wait	0	; no getkey since we have a messagebox
OPT_Assembler	JWasm	; delete the x to
OPT_Linker	polink	; activate these options
OPT_Arg1	test.png	; a png image file
OPT_Arg2	/jpeg	; destination jpg
OPT_Susy	Windows
OPT_Tmp2Asm	1
